package com.youli.mybatis.dao;

import java.util.List;

import org.apache.log4j.Logger;
import org.junit.Test;

import com.youli.mybatis.bean.Book;

/**
* author: youli
* 2022-10-21 22:34:16
*/
public class BookDaoTest {
	
	private Logger insertLogger = Logger.getLogger("insert");
	private Logger updateLogger = Logger.getLogger("update");
	private Logger deleteLogger = Logger.getLogger("delete");
	private Logger selectLogger = Logger.getLogger("select");
	private Logger listLogger = Logger.getLogger("list");
	
	private BookDao bookDao = new BookDao();
	
	@Test
	public void testSelectById() throws Exception {
		//写日志头
		selectLogger.debug("begin");
		selectLogger.debug("device");//tbl_book,device
		//测试逻辑
		Book aa = bookDao.selectById(1);
		//写日志尾
		selectLogger.debug(aa != null);
		selectLogger.debug("end");
	}

	@Test
	public void testSelectList() throws Exception {
		//写日志头
		listLogger.debug("begin");
		listLogger.debug("book");
		//测试逻辑
		List<Book> list = bookDao.selectList();
		//写日志尾
		listLogger.debug(list.size());
		listLogger.debug("end");
	}

	@Test
	public void testInsert() throws Exception {
		//写日志头
		insertLogger.debug("begin");
		insertLogger.debug("book");
		//测试逻辑
		Book book = new Book();
		book.setBookAuthor("jinyong");
		book.setBookName("lu ding ji");
		book.setBookPrice(18.5);
		book.setPublisherName("hua cheng chu ban she");
		int ret = bookDao.insert(book);
		//写日志尾
		insertLogger.debug(ret == 1);
		insertLogger.debug("end");
	}

	@Test
	public void testUpdate() throws Exception {
		//写日志头
		updateLogger.debug("begin");
		updateLogger.debug("book");
		//测试逻辑
		Book book = bookDao.selectById(1);
		String oldName = book.getBookName();
		updateLogger.debug("oldName="+ oldName);
		book.setBookName("hehe");
		int ret = bookDao.update(book);
		book = bookDao.selectById(1);
		String newName = book.getBookName();
		updateLogger.debug("newName="+ book.getBookName());
		//写日志尾
		updateLogger.debug(oldName == newName);
		updateLogger.debug(ret == 1);
		updateLogger.debug("end");
	}

	@Test
	public void testDelete() throws Exception {
		//写日志头
		deleteLogger.debug("begin");
		deleteLogger.debug("book");
		//测试逻辑
		int ret = bookDao.delete(3);
		//写日志尾
		deleteLogger.debug(ret == 1);
		deleteLogger.debug("end");
	}

}
